//
//  LAAlert.h
//  LAAdditions
//
//  Created by Cyril Anger on 25/04/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <AppKit/AppKit.h>

@class LAAlert;

typedef void (^LAAlertBlock)(LAAlert *alert, NSInteger clickedIndex);

@interface LAAlert : NSAlert

@property (nonatomic, readonly) NSInteger cancelButtonIndex;
@property (copy, nonatomic) LAAlertBlock block;

- (id)initWithTitle:(NSString *)title message:(NSString *)message cancelButtonTitle:(NSString *)cancelButtonTitle otherButtonTitles:(NSString *)otherButtonTitles, ...;
- (void)setAccessoryView:(NSView *)accessoryView maxHeight:(CGFloat)maxHeight;
- (void)showUsingBlock:(LAAlertBlock)block;
- (void)showInWindow:(NSWindow *)window usingBlock:(LAAlertBlock)block;
- (void)showInWindow:(NSWindow *)window ofDocument:(NSDocument *)document usingBlock:(LAAlertBlock)block;
- (void)dismiss;
- (void)addActivityIndicator;

@end
