//
//  LAAppDelegate.h
//  LAAdditions
//
//  Created by Cyril Anger on 06/10/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <LAAdditions/LAWebController.h>

extern NSString *LAUserInterfaceSizeDidChangeNotification;
extern NSString *LAUpdateUserInterfaceNotification;

@interface LAAppDelegate : NSObject <NSApplicationDelegate, NSWindowDelegate, NSToolbarDelegate, WebPolicyDelegate>

@property (nonatomic, readonly) NSInteger numberOfMinutesInBackground;
@property (nonatomic) NSInteger userInterfaceSize;
@property (nonatomic, readonly) NSArray *preferencesPanes;

- (NSDictionary *)defaultsForUserInterfaceSize:(NSInteger)userInterfaceSize;
- (NSView *)viewForPreferencesPane:(NSString *)name;
- (void)selectPreferencesPane:(NSString *)name display:(BOOL)display;
- (void)checkForUpdatesAndNotify:(BOOL)notify;
- (void)showHelpAtAnchor:(NSString *)anchor;

- (IBAction)checkForUpdates:(id)sender;
- (IBAction)openSampleDocument:(id)sender;
- (IBAction)showWelcomeWindow:(id)sender;
- (IBAction)closeWelcomeWindow:(id)sender;
- (IBAction)showPreferencesWindow:(id)sender;
- (IBAction)showHelp:(id)sender;

@end
