//
//  LAApplicationAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 17/08/05.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#else
#import <AppKit/AppKit.h>
#endif

#if TARGET_OS_IPHONE
#define LAApplication UIApplication
#else
#define LAApplication NSApplication
#endif

@interface LAApplication (LAApplicationAdditions)

@property (readonly) NSString *name;
@property (readonly) NSString *displayName;
@property (readonly) NSString *path;
@property (readonly) NSString *version;
#if !TARGET_OS_IPHONE
@property (readonly) NSString *systemVersion;
@property (readonly) NSString *hardwareModel;
@property (readonly) NSString *MACAddress;
#endif
@property (readonly) NSString *IPv4Address;
@property (readonly) NSString *IPv6Address;
#if !TARGET_OS_IPHONE
@property (getter = isLaunchedAtLogin) BOOL launchedAtLogin;
#endif
@property (readonly) NSArray *documentExtensions;

#if TARGET_OS_IPHONE
- (void)enableIdleTimer;
- (void)disableIdleTimer;
#else
- (void)sendMailWithSubject:(NSString *)subject content:(NSString *)content toRecipients:(NSArray *)recipients attachments:(NSArray *)attachments;
#endif

@end
