//
//  LAAttachedWindow.h
//  LAAdditions
//
//  Created by Cyril Anger on 04/06/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LAViewController.h>

@class LAAttachedWindow;

typedef void (^LAAttachedWindowBlock)(LAAttachedWindow *attachedWindow);

@interface LAAttachedWindow : NSWindow <NSWindowDelegate>

@property (strong, nonatomic) LAViewController *rootViewController;

+ (LAAttachedWindow *)attachedWindowWithRootViewController:(LAViewController *)rootViewController frameAutosaveName:(NSString *)frameAutosaveName;

- (id)initWithRootViewController:(LAViewController *)rootViewController;
- (void)setRootViewController:(LAViewController *)rootViewController animated:(BOOL)animated;
- (void)beginSheetInWindow:(NSWindow *)window usingBlock:(LAAttachedWindowBlock)block;
- (void)beginSheetInWindow:(NSWindow *)window ofDocument:(NSDocument *)document usingBlock:(LAAttachedWindowBlock)block;

- (IBAction)cancelSheet:(id)sender;
- (IBAction)validateSheet:(id)sender;

@end
