//
//  LABadgeView.h
//  LAAdditions
//
//  Created by Cyril Anger on 20/12/2013.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <LAAdditions/LAFontAdditions.h>
#import <LAAdditions/LAViewAdditions.h>

IB_DESIGNABLE
@interface LABadgeView : LAControl

@property (strong, nonatomic) IBInspectable NSString *text;
@property (nonatomic) IBInspectable NSInteger value;
@property (strong, nonatomic) IBInspectable NSString *label;
@property (strong, nonatomic) IBInspectable LAFont *font;
@property (strong, nonatomic) IBInspectable LAColor *textColor;
@property (strong, nonatomic) IBInspectable LAColor *badgeColor;
@property (strong, nonatomic) IBInspectable LAColor *outlineColor;
@property (nonatomic) IBInspectable CGFloat outlineWidth;
@property (strong, nonatomic) IBInspectable LAColor *backgroundSelectionColor;

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *collapsingConstraint;

- (void)anchorToCorner:(LARectCorner)corner withOffset:(CGSize)offset;

@end

@interface LAView (LABadgeViewAdditions)

@property (nonatomic, readonly) LABadgeView *badge;

@end
