//
//  LABundleAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 10/12/05.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#define LAIdentifierLocalizedString(key, identifier) NSLocalizedStringFromTableInBundle(key, nil, [NSBundle bundleWithIdentifier:identifier], nil)
#define LANumberAwareIdentifierLocalizedString(number, singleKey, pluralKey, identifier) (number <= 1 ? LAIdentifierLocalizedString(singleKey, identifier) : LAIdentifierLocalizedString(pluralKey, identifier))
#define LALocalizedString(key) LAIdentifierLocalizedString(key, @"com.lyricapps.LAAdditions")
#define LANumberAwareLocalizedString(number, singleKey, pluralKey) LANumberAwareIdentifierLocalizedString(number, singleKey, pluralKey, @"com.lyricapps.LAAdditions")
#define NSNumberAwareLocalizedString(number, singleKey, pluralKey) LANumberAwareIdentifierLocalizedString(number, singleKey, pluralKey, [[NSBundle mainBundle] bundleIdentifier])

@interface NSBundle (LABundleAdditions)

@property (readonly) NSString *executable;
@property (readonly) NSString *displayName;
@property (readonly) NSString *version;

+ (instancetype)libraryBundle;

@end
