//
//  LAButton.h
//  LAAdditions
//
//  Created by Cyril Anger on 15/04/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAImageAdditions.h>

@class LAButtonCell, LAButton;

typedef void (^LAButtonCellBlock)(LAButtonCell *cell);
typedef void (^LAButtonBlock)(LAButton *button);

@interface LAButtonCell : NSButtonCell

@property (nonatomic, readonly) BOOL mouseInside;
@property (strong, nonatomic) LAColor *titleColor;
@property (strong, nonatomic) LAColor *highlightedTitleColor;
@property (strong, nonatomic) LAColor *disabledTitleColor;
@property (strong, nonatomic) NSShadow *titleShadow;
@property (strong, nonatomic) LAColor *titleShadowColor;
@property (nonatomic) LASize titleShadowOffset;
@property (strong, nonatomic) LAImage *backgroundImage;
@property (nonatomic) BOOL backgroundImageDimsWhenDisabled;
@property (nonatomic) LAEdgeInsets capInsets;
@property (weak, nonatomic) NSString *capInsetsComponents;
@property (nonatomic) LAEdgeInsets contentInsets;
@property (weak, nonatomic) NSString *contentInsetsComponents;
@property (copy, nonatomic) LAButtonCellBlock block;

@end

@interface LAButton : NSButton

@property (strong, nonatomic) LAColor *titleColor;
@property (strong, nonatomic) LAColor *highlightedTitleColor;
@property (strong, nonatomic) LAColor *disabledTitleColor;
@property (strong, nonatomic) NSShadow *titleShadow;
@property (strong, nonatomic) LAColor *titleShadowColor;
@property (nonatomic) LASize titleShadowOffset;
@property (strong, nonatomic) LAImage *backgroundImage;
@property (nonatomic) LAEdgeInsets capInsets;
@property (strong, nonatomic) NSString *capInsetsComponents;
@property (nonatomic) LAEdgeInsets contentInsets;
@property (strong, nonatomic) NSString *contentInsetsComponents;
@property (copy, nonatomic) LAButtonBlock block;

+ (instancetype)buttonWithTitle:(NSString *)title image:(LAImage *)image block:(LAButtonBlock)block NS_AVAILABLE_MAC(10_12);
+ (instancetype)buttonWithTitle:(NSString *)title block:(LAButtonBlock)block NS_AVAILABLE_MAC(10_12);
+ (instancetype)buttonWithImage:(LAImage *)image block:(LAButtonBlock)block NS_AVAILABLE_MAC(10_12);

@end
