//
//  LACSVImportController.h
//  LAAdditions
//
//  Created by Cyril Anger on 12/08/2015.
//  Copyright (c) 2015 LyricApps. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <LAAdditions/LAViewController.h>
#import <LAAdditions/LADateFormatter.h>
#import <LAAdditions/LANumberFormatter.h>
#import <LAAdditions/LAObserverPopUpButton.h>
#import <LAAdditions/LAButton.h>

@class LACSVImportController;

typedef void (^LACSVImportControllerBlock)(LACSVImportController *controller, NSArray *rows, NSDictionary *mapping, LADateFormatter *dateFormatter, LANumberFormatter *numberFormatter);

@interface LACSVImportController : LAEditViewController

@property (nonatomic) BOOL hasDates;
@property (nonatomic) BOOL hasNumbers;
@property (strong, nonatomic) NSArray *keyPaths;
@property (strong, nonatomic) NSString *autosaveName;

@property (weak, nonatomic) IBOutlet LAObserverPopUpButton *encodingButton;
@property (weak, nonatomic) IBOutlet LATextField *dateFormatField;
@property (weak, nonatomic) IBOutlet LAObserverPopUpButton *decimalSeparatorButton;
@property (weak, nonatomic) IBOutlet LAObserverPopUpButton *groupingSeparatorButton;
@property (weak, nonatomic) IBOutlet LAObserverPopUpButton *separatorButton;
@property (weak, nonatomic) IBOutlet LATextField *firstLineField;
@property (weak, nonatomic) IBOutlet LAButton *hasHeaderButton;

- (id)initWithBlock:(LACSVImportControllerBlock)block;
- (void)showOpenPanelInWindow:(NSWindow *)window;

@end
