//
//  LAColorAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 06/02/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#else
#import <AppKit/AppKit.h>
#endif

#if TARGET_OS_IPHONE
#define LAColor UIColor
#else
#define LAColor NSColor
#endif

@interface LAColor (LAColorAdditions)

#if TARGET_OS_IPHONE
- (CGFloat)redComponent;
- (CGFloat)greenComponent;
- (CGFloat)blueComponent;
- (CGFloat)alphaComponent;
- (CGFloat)saturationComponent;
- (CGFloat)brightnessComponent;
#else
+ (LAColor *)colorWithWhite:(CGFloat)white alpha:(CGFloat)alpha;
+ (LAColor *)colorWithRed:(CGFloat)red green:(CGFloat)green blue:(CGFloat)blue alpha:(CGFloat)alpha;
+ (LAColor *)colorWithHue:(CGFloat)hue saturation:(CGFloat)saturation brightness:(CGFloat)brightness alpha:(CGFloat)alpha;
#endif
- (LAColor *)RGBColor;
+ (LAColor *)colorWithComponents:(NSString *)components;
- (NSString *)components;
+ (LAColor *)colorWithWebColor:(NSString *)webColor;
- (NSString *)webColor;
- (BOOL)isEqualToColor:(LAColor *)color;
- (void)getL:(CGFloat *)l a:(CGFloat *)a b:(CGFloat *)b;

#if TARGET_OS_IPHONE
- (LAColor *)highlightWithLevel:(CGFloat)level;
- (LAColor *)shadowWithLevel:(CGFloat)level;
#endif
- (LAColor *)clearWithLevel:(CGFloat)level;
- (LAColor *)desaturateWithLevel:(CGFloat)level;
- (LAColor *)borderColor;

@end
