//
//  LACondition.h
//  LAAdditions
//
//  Created by Cyril Anger on 01/10/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LATemplate.h>
#import <LAAdditions/LAOrderedMap.h>
#import <LAAdditions/LAParameter.h>

@class LACompoundCondition;

@interface LACondition : LADatabaseObject <LATemplateControlledObject>

@property (getter = isLeaf, nonatomic, readonly) BOOL leaf;
@property (weak, nonatomic) LACompoundCondition *parent;
@property (nonatomic) long long index;

#pragma mark Predicate

+ (id)conditionFromPredicate:(NSPredicate *)predicate withTemplates:(LAOrderedMap *)templates inDatabaseManager:(LADatabaseManager *)databaseManager;
@property (readonly) NSPredicate *predicate;

@end

@interface LACompoundCondition : LACondition

@property (weak, nonatomic) LADatabaseObject *owner;
@property (nonatomic) NSCompoundPredicateType type;
@property (weak) NSString *typeName;
@property (strong, nonatomic) NSMutableArray *conditions;
- (void)insertConditions:(NSArray *)conditions atIndexes:(NSIndexSet *)indexes;
- (void)removeConditionsAtIndexes:(NSIndexSet *)indexes;
- (void)addConditions:(NSArray *)conditions;
- (void)removeConditions:(NSArray *)conditions;

#pragma mark Template

+ (LAOrderedMap *)conditionTemplates;

@end

@interface LAComparisonCondition : LACondition

@property (strong, nonatomic) NSString *keyPath;
@property (strong, nonatomic) NSString *operator;
@property (strong, nonatomic) LAParameter *parameter;

@end
