//
//  LAConstant.h
//  LAAdditions
//
//  Created by Cyril Anger on 30/03/08.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAObject.h>

@interface LAConstantsManager : NSObject

@property (strong, nonatomic, readonly) NSMutableArray *constants;
@property (strong, nonatomic, readonly) NSMutableDictionary *names;
@property (strong, nonatomic, readonly) NSMutableDictionary *values;

@end

@interface LAConstant : NSObject <LAObject>

@property (strong, nonatomic, readonly) NSString *name;
@property (nonatomic, readonly) NSInteger value;

+ (LAConstantsManager *)sharedManager;
+ (NSArray *)constants;
+ (instancetype)constantWithName:(NSString *)name;
+ (instancetype)constantWithDescription:(NSString *)description;
+ (instancetype)constantWithValue:(NSInteger)value;
+ (void)addConstant:(LAConstant *)constant;

- (instancetype)initWithName:(NSString *)name value:(NSInteger)value;
- (NSComparisonResult)compare:(LAConstant *)constant;

@end

@interface LABoolean : LAConstant

+ (LABoolean *)falseBoolean;
+ (LABoolean *)trueBoolean;

@end
