//
//  LADatabaseSynchronizationSession.h
//  LAAdditions
//
//  Created by Cyril Anger on 09/11/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LADatabaseManager.h>
#import <LAAdditions/LADatabaseObject.h>

@interface LADatabaseSynchronizationSession : NSObject

@property (nonatomic, readonly) NSUInteger numberOfSteps;
@property (nonatomic) NSUInteger currentStep;
@property (strong, nonatomic) LAImage *otherIcon;
@property (strong, nonatomic, readonly) NSArray *changes;
@property (nonatomic, readonly) NSUInteger progress;
@property (nonatomic, readonly) NSUInteger maxProgress;
@property (getter = isCanceled, readonly) BOOL canceled;

- (id)initWithDatabaseManager:(LADatabaseManager *)databaseManager otherDatabaseURL:(NSURL *)otherDatabaseURL;
- (BOOL)createOtherDatabaseManagerAndReturnError:(NSError * __autoreleasing *)error;
- (void)prepareSynchronization;
- (void)computeChanges;
- (void)applyChanges;
- (void)cancel;

@end

@protocol LADatabaseSynchronizationSessionController <NSObject>

- (void)cancel;

@end
