//
//  LADateAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 26/04/08.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSDate (LADateAdditions)

@property (readonly) NSInteger yearOfCommonEra;
@property (readonly) NSInteger monthOfYear;
@property (readonly) NSInteger dayOfMonth;
@property (readonly) NSInteger hourOfDay;
@property (readonly) NSInteger minuteOfHour;
@property (readonly) NSInteger secondOfMinute;

+ (NSDate *)today;
+ (NSDate *)dateWithYear:(NSInteger)year month:(NSUInteger)month day:(NSUInteger)day;
+ (NSDate *)dateWithYear:(NSInteger)year month:(NSUInteger)month day:(NSUInteger)day hour:(NSUInteger)hour minute:(NSUInteger)minute second:(NSUInteger)second;
- (NSDate *)dateByAddingYears:(NSInteger)years months:(NSInteger)months days:(NSInteger)days;
- (NSDate *)dateByAddingYears:(NSInteger)years months:(NSInteger)months days:(NSInteger)days hours:(NSInteger)hours minutes:(NSInteger)minutes seconds:(NSInteger)seconds;
- (NSDate *)startOfDay;
- (NSDate *)endOfDay;
- (NSDate *)startOfWeek;
- (NSDate *)endOfWeek;
- (NSDate *)startOfMonth;
- (NSDate *)endOfMonth;
- (NSDate *)startOfYear;
- (NSDate *)endOfYear;
- (NSDate *)updateFromTimeZoneWithName:(NSString *)name;
- (BOOL)isEqualToDateIgnoringTime:(NSDate *)date;
- (NSComparisonResult)compareIgnoringTime:(NSDate *)date;

@end
