//
//  LADecimalNumberAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 06/02/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSNumber (LADecimalNumberAdditions)

- (NSDecimalNumber *)decimalNumber;

@end

@interface NSDecimalNumber (LADecimalNumberAdditions)

+ (NSDecimalNumber *)decimalNumberWithInteger:(NSInteger)value;
+ (NSDecimalNumber *)decimalNumberWithDouble:(double)value precision:(short)precision;

- (NSDecimalNumber *)oppositeDecimalNumber;
- (NSDecimalNumber *)absoluteDecimalNumber;
- (NSDecimalNumber *)reminderOfDivisionBy:(NSDecimalNumber *)decimalNumber;
- (NSDecimalNumber *)minimum:(NSDecimalNumber *)number;
- (NSDecimalNumber *)maximum:(NSDecimalNumber *)number;
- (BOOL)hasDifferentSignThanDecimalNumber:(NSDecimalNumber *)number;
- (BOOL)isEqualToDecimalNumber:(NSDecimalNumber *)number withPrecision:(short)precision;

@end
