//
//  LADocument.h
//  LAAdditions
//
//  Created by Cyril Anger on 20/06/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LADatabaseManager.h>
#import <LAAdditions/LAMainViewController.h>
#import <LAAdditions/LAPrintView.h>

@interface LADocument : NSDocument <LADatabaseManagerDocument, NSWindowDelegate>

@property (strong) LADatabaseManager *databaseManager;
@property (getter = isProtected, nonatomic) BOOL protected;
@property (nonatomic, readonly) NSString *currentPrintInfoName;
@property (nonatomic, readonly) NSInteger numberOfMinutesInBackground;

@property (strong, nonatomic) IBOutlet LAMainViewController *mainViewController;
@property (strong, nonatomic) IBOutlet NSView *unlockView;
@property (weak, nonatomic) IBOutlet NSTextField *unlockPasswordField;
@property (strong, nonatomic) IBOutlet NSView *lockView;
@property (weak, nonatomic) IBOutlet NSTextField *lockPasswordField;
@property (weak, nonatomic) IBOutlet NSTextField *lockNewPasswordField;
@property (weak, nonatomic) IBOutlet NSTextField *lockConfirmPasswordField;
@property (weak, nonatomic) IBOutlet NSButton *lockRemoveButton;

+ (Class)databaseManagerClass;

- (void)restoreContentsOfURL:(NSURL *)URL completionHandler:(void (^)(NSError *error))completionHandler;
- (void)saveAndZipDocumentWithCompletionHandler:(void (^)(NSString *file, NSString *name, NSString *error))completionHandler;
- (void)unzipAndRestoreDocumentFromArchive:(NSString *)archive withCompletionHandler:(void (^)(NSString *error))completionHandler;
- (BOOL)unlockWithPassword:(NSString *)password;
- (void)activateUnlockController;
- (void)restorePrintInfos:(NSDictionary *)printInfos;
- (void)configureDefaultPrintInfo:(NSPrintInfo *)printInfo forName:(NSString *)name;
- (NSPrintOperation *)printOperationWithView:(NSView *)view accessoryController:(NSViewController <NSPrintPanelAccessorizing> *)accessoryController;
- (NSPrintOperation *)PDFOperationWithView:(NSView *)view toPath:(NSString *)path;
- (void)printView:(LAPrintView *)view;
- (void)exportView:(LAPrintView *)view toPDFAtPath:(NSString *)path completionHandler:(void (^)(void))completionHandler;
- (void)printHTMLString:(NSString *)string;
- (void)exportHTMLString:(NSString *)string toPDFAtPath:(NSString *)path completionHandler:(void (^)(void))completionHandler;
- (void)documentWillBecomeActive;

- (IBAction)showUnlockView:(id)sender;
- (IBAction)hideUnlockView:(id)sender;
- (IBAction)unlock:(id)sender;
- (IBAction)showLockView:(id)sender;
- (IBAction)hideLockView:(id)sender;
- (IBAction)lock:(id)sender;
- (IBAction)removeLock:(id)sender;

@end
