//
//  LADuration.h
//  LAAdditions
//
//  Created by Cyril Anger on 01/07/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum {
	LADurationUnitDay,
	LADurationUnitWeek,
	LADurationUnitMonth,
	LADurationUnitYear
} LADurationUnit;

@interface LADuration : NSObject <NSCoding, NSCopying>

- (instancetype)initWithUnit:(LADurationUnit)unit numberOfUnits:(NSInteger)numberOfUnits NS_DESIGNATED_INITIALIZER;
@property (nonatomic, readonly) LADurationUnit unit;
@property (nonatomic, readonly) NSInteger numberOfUnits;
+ (LADuration *)durationWithDays:(NSInteger)days;
@property (nonatomic, readonly) NSInteger days;
+ (LADuration *)durationWithWeeks:(NSInteger)weeks;
@property (nonatomic, readonly) NSInteger weeks;
+ (LADuration *)durationWithMonths:(NSInteger)months;
@property (nonatomic, readonly) NSInteger months;
+ (LADuration *)durationWithYears:(NSInteger)years;
@property (nonatomic, readonly) NSInteger years;
@property (getter = isValid, nonatomic, readonly) BOOL valid;
- (NSDate *)addToDate:(NSDate *)date count:(NSInteger)count;
- (NSInteger)numberOfPeriodsBetweenDate:(NSDate *)startDate andDate:(NSDate *)endDate includingRemainingDays:(BOOL)includingRemainingDays;
- (NSComparisonResult)compare:(LADuration *)duration;

@end
