//
//  LAFilter.h
//  LAAdditions
//
//  Created by Cyril Anger on 24/09/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LACondition.h>
#import <LAAdditions/LAImageAdditions.h>

@class LAFiltersBarData;

typedef enum {
	LAFilterTypeSimple,
	LAFilterTypeList,
	LAFilterTypeString,
	LAFilterTypeDate,
	LAFilterTypeNumber
} LAFilterType;

@interface LAFilter : NSObject

- (id)initWithName:(NSString *)name type:(LAFilterType)type predicate:(NSPredicate *)predicate tag:(NSInteger)tag enabled:(BOOL)enabled hidden:(BOOL)hidden;
@property (strong, nonatomic, readonly) NSString *name;
@property (readonly) NSString *title;
@property (nonatomic, readonly) LAFilterType type;
@property (strong, nonatomic, readonly) NSPredicate *predicate;
@property (nonatomic, readonly) NSInteger tag;
@property (getter = isEnabled, nonatomic) BOOL enabled;
@property (getter = isHidden, nonatomic) BOOL hidden;
- (BOOL)isCompatibleWithFilter:(LAFilter *)filter;
@property (strong, nonatomic) id widget;

@end

@interface LASavedCondition : LADatabaseObject

@property (weak, nonatomic) LAFiltersBarData *filtersBarData;
@property (nonatomic) long long index;
@property (strong, nonatomic) NSString *name;
@property (nonatomic, readonly) LAImage *icon;
@property (strong, nonatomic) LACompoundCondition *condition;

@end

@interface LAFiltersBarData : LADatabaseObject

@property (strong, nonatomic) NSString *name;
@property (strong, nonatomic) NSDictionary *values;
@property (strong, nonatomic) LACompoundCondition *condition;
@property (strong, nonatomic) NSMutableArray *savedConditions;
- (void)insertSavedConditions:(NSArray *)savedConditions atIndexes:(NSIndexSet *)indexes;
- (void)removeSavedConditionsAtIndexes:(NSIndexSet *)indexes;
- (void)addSavedConditions:(NSArray *)savedConditions;
- (void)removeSavedConditions:(NSArray *)savedConditions;
- (void)sortSavedConditionsAlphabetically;

@end
