//
//  LAFiltersBar.h
//  LAAdditions
//
//  Created by Cyril Anger on 25/09/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAFilter.h>
#import <LAAdditions/LAObserverPopUpButton.h>
#import <LAAdditions/LASectionsController.h>
#import <LAAdditions/LAConditionsController.h>
#import <LAAdditions/LATextField.h>
#import <LAAdditions/LABackgroundView.h>

@interface LAFiltersBar : NSControl <NSMenuDelegate>

@property (strong, nonatomic) NSString *autosaveName;
@property (nonatomic) BOOL showsSortButton;
@property (nonatomic) BOOL allowsCustomization;
@property (strong, nonatomic) NSArray *filters;
@property (strong, nonatomic) LADatabaseManager *databaseManager;
@property (strong, nonatomic) NSDictionary *values;
@property (strong, nonatomic) NSPredicate *predicate;
@property (strong, nonatomic) NSPredicate *customPredicate;
@property (getter = isExpanded, nonatomic) BOOL expanded;
@property (strong, nonatomic, readonly) LAObserverPopUpButton *savedConditionsButton;
@property (strong, nonatomic, readonly) LASingleDataSourceSectionsController *savedConditionsController;
@property (strong, nonatomic, readonly) LAConditionsController *conditionsController;
@property (readonly) CGFloat lineHeight;

@property (weak, nonatomic) IBOutlet LATreeNodesDataSource *dataSource;
@property (weak, nonatomic) IBOutlet NSSearchField *searchField;
@property (weak, nonatomic) IBOutlet NSView *editView;

+ (LAColor *)backgroundColor;
+ (void)setBackgroundColor:(LAColor *)backgroundColor;
+ (LAColor *)borderColor;
+ (void)setBorderColor:(LAColor *)borderColor;
+ (LAColor *)textColor;
+ (void)setTextColor:(LAColor *)textColor;

- (void)loadSavedConditionsController;
- (void)unloadSavedConditionsController;
- (void)loadConditionsController;
- (void)unloadConditionsController;
- (LAFilter *)filterNamed:(NSString *)name;
- (void)setExpanded:(BOOL)expanded animated:(BOOL)animated;
- (NSButton *)makeButtonWithTitle:(NSString *)title;
- (LAObserverPopUpButton *)makePopUpButtonWithTitle:(NSString *)title;
- (LATextField *)makeField:(Class)class withTitle:(NSString *)title;
- (LABackgroundView *)makeSeparator;

@end

@interface LASavedConditionsDataSource : LATreeNodesDataSource

- (IBAction)sortAlphabetically:(id)sender;

@end
