//
//  LAFontAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 14/04/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#else
#import <AppKit/AppKit.h>
#endif

#if TARGET_OS_IPHONE
#define LAFont UIFont
#define LAFontWeightUltraLight UIFontWeightUltraLight
#define LAFontWeightThin UIFontWeightThin
#define LAFontWeightLight UIFontWeightLight
#define LAFontWeightRegular UIFontWeightRegular
#define LAFontWeightMedium UIFontWeightMedium
#define LAFontWeightSemibold UIFontWeightSemibold
#define LAFontWeightBold UIFontWeightBold
#define LAFontWeightHeavy UIFontWeightHeavy
#define LAFontWeightBlack UIFontWeightBlack
#else
#define LAFont NSFont
#define LAFontWeightUltraLight NSFontWeightUltraLight
#define LAFontWeightThin NSFontWeightThin
#define LAFontWeightLight NSFontWeightLight
#define LAFontWeightRegular NSFontWeightRegular
#define LAFontWeightMedium NSFontWeightMedium
#define LAFontWeightSemibold NSFontWeightSemibold
#define LAFontWeightBold NSFontWeightBold
#define LAFontWeightHeavy NSFontWeightHeavy
#define LAFontWeightBlack NSFontWeightBlack
#define NSTextAlignmentLeft NSLeftTextAlignment
#define NSTextAlignmentCenter NSCenterTextAlignment
#define NSTextAlignmentRight NSRightTextAlignment
#endif

@interface LAFont (LAFontAdditions)

- (LAFont *)fontWithSize:(CGFloat)fontSize;
- (LAFont *)smallerFont:(CGFloat)delta;
- (LAFont *)biggerFont:(CGFloat)delta;

@end
