//
//  LAGraphicsAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 08/05/13.
//  Copyright (c) 2013 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAStringAdditions.h>

#if TARGET_OS_IPHONE
#define LAGraphicsGetCurrentContext() UIGraphicsGetCurrentContext()
#else
#define LAGraphicsGetCurrentContext() [[NSGraphicsContext currentContext] graphicsPort]
#endif

extern CGFloat LAGraphicsGetMargin();
extern void LAGraphicsSetMargin(CGFloat newMargin);
extern CGFloat LAGraphicsGetImageMargin();
extern void LAGraphicsSetImageMargin(CGFloat newImageMargin);
extern LARect LAGraphicsDrawText(NSString *text, LARect rect, CGFloat maxWidth, LAFont *font, LAColor *color, NSTextAlignment alignment, LAColor *shadowColor, LASize shadowOffset, CGFloat shadowBlur);
extern LARect LAGraphicsDrawImage(LAImage *image, LASize size, LARect rect, CGFloat maxWidth, NSTextAlignment alignment);
extern LARect LAGraphicsDrawImageAndText(LAImage *image, LASize size, NSString *text, LARect rect, CGFloat maxWidth, LAFont *font, LAColor *color, NSTextAlignment alignment, LAColor *shadowColor, LASize shadowOffset, CGFloat shadowBlur);
