//
//  LAInlineColorPicker.h
//  LAAdditions
//
//  Created by Cyril Anger on 28/09/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAViewAdditions.h>
#import <LAAdditions/LAColorAdditions.h>
#if !TARGET_OS_IPHONE
#import <LAAdditions/LATextField.h>
#endif

@class LAInlineColorPicker;

typedef void (^LAInlineColorPickerBlock)(LAInlineColorPicker *colorPicker, LAColor *selectedColor);

IB_DESIGNABLE
@interface LAInlineColorPicker : LAControl

@property (strong, nonatomic) NSArray *colors;
@property (strong, nonatomic) LAColor *selectedColor;
@property (copy, nonatomic) LAInlineColorPickerBlock block;

@end

#if !TARGET_OS_IPHONE

@interface LAInlineColorPickerMenuItem : NSMenuItem

@property (weak, nonatomic) IBOutlet LATextField *titleLabel;
@property (weak, nonatomic) IBOutlet LAInlineColorPicker *picker;

- (IBAction)changeColor:(id)sender;

@end

#endif
