//
//  LALink.h
//  LAAdditions
//
//  Created by Cyril Anger on 27/08/09.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <QuickLook/QuickLook.h>
#else
#import <Quartz/Quartz.h>
#endif

#import <LAAdditions/LAImageAdditions.h>

#if TARGET_OS_IPHONE
#define LAPasteboard UIPasteboard
#else
#define LAPasteboard NSPasteboard
#endif

@interface LALink : NSObject <NSCoding, QLPreviewItem>

@property (readonly) NSString *name;
@property (readonly) LAImage *icon;

+ (NSString *)pasteboardType;
+ (NSArray *)linksFromPasteboard:(LAPasteboard *)pasteboard;

- (BOOL)isEqualToLink:(LALink *)link;
- (void)resolve;
- (void)show;

@end

@interface LAFileLink : LALink

@property (strong, nonatomic, readonly) NSURL *URL;
@property (strong, nonatomic, readonly) NSData *bookmarkData;
@property (strong, nonatomic, readonly) NSData *aliasData;
@property (strong, nonatomic, readonly) NSData *data;
@property (nonatomic) BOOL storeData;

+ (NSURL *)saveDirectory;
+ (LASize)imageMaxSize;
+ (void)setImageMaxSize:(LASize)newImageMaxSize;

- (id)initWithURL:(NSURL *)URL;
- (void)store;
- (void)extractInFolder:(NSString *)folder;

@end

@interface LAMailLink : LALink

@property (strong, nonatomic, readonly) NSString *mailID;
@property (strong, nonatomic, readonly) NSString *subject;

- (id)initWithMailID:(NSString *)mailID subject:(NSString *)subject;

@end

@protocol LALinksContainer <NSObject>

@property (strong, nonatomic) NSArray *links;

@end
