//
//  LAMainViewController.h
//  LAAdditions
//
//  Created by Cyril Anger on 27/02/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAButton.h>
#import <LAAdditions/LAViewController.h>
#import <LAAdditions/LABackgroundView.h>

@interface LAMainViewControllerButton : LAButton

@property (strong, nonatomic) IBInspectable NSString *autosaveName;
@property (getter = isActive, nonatomic) BOOL active;
@property (nonatomic) CGFloat length;

@property (strong, nonatomic) IBOutlet NSView *view;

@end

@interface LAMainViewController : LAViewController

@property (strong, nonatomic) NSView *leftView;
@property (strong, nonatomic) LAMainViewControllerButton *leftViewButton;
@property (strong, nonatomic) NSView *leftBarView;
@property (strong, nonatomic) NSView *contentView;
@property (strong, nonatomic) NSView *bottomView;
@property (strong, nonatomic) NSArray *bottomViewButtons;
@property (strong, nonatomic) NSView *rightView;
@property (strong, nonatomic) NSArray *rightViewButtons;
@property (strong, nonatomic) NSView *contentBarView;

@property (strong, nonatomic) IBOutlet NSSegmentedControl *viewControl;

- (void)setLeftView:(NSView *)leftView withWidth:(CGFloat)width show:(BOOL)show animated:(BOOL)animated completionHandler:(void (^)(void))completionHandler;
- (void)setBottomView:(NSView *)bottomView withHeight:(CGFloat)height show:(BOOL)show animated:(BOOL)animated completionHandler:(void (^)(void))completionHandler;
- (void)setRightView:(NSView *)rightView withWidth:(CGFloat)width show:(BOOL)show animated:(BOOL)animated completionHandler:(void (^)(void))completionHandler;

- (IBAction)changeView:(id)sender;

@end

@interface LAMainView : NSView

@property (nonatomic) BOOL leftViewEnabled;
@property (nonatomic) BOOL leftViewVisible;
@property (nonatomic, readonly) CGFloat leftViewWidth;
@property (nonatomic) CGFloat bottomSeparatorHeight;
@property (nonatomic) BOOL bottomViewEnabled;
@property (nonatomic) BOOL bottomViewVisible;
@property (nonatomic, readonly) CGFloat bottomViewHeight;
@property (nonatomic) BOOL rightViewEnabled;
@property (nonatomic) BOOL rightViewVisible;
@property (nonatomic, readonly) CGFloat rightViewWidth;
@property (nonatomic) CGFloat contentBarHeight;

@property (weak, nonatomic) IBOutlet LABackgroundView *leftView;
@property (weak, nonatomic) IBOutlet LABackgroundView *leftBarView;
@property (weak, nonatomic) IBOutlet LABackgroundView *leftSeparator;
@property (weak, nonatomic) IBOutlet LABackgroundView *contentView;
@property (weak, nonatomic) IBOutlet LABackgroundView *bottomSeparator;
@property (weak, nonatomic) IBOutlet NSImageView *bottomSeparatorThumb;
@property (weak, nonatomic) IBOutlet LABackgroundView *bottomView;
@property (weak, nonatomic) IBOutlet LABackgroundView *rightSeparator;
@property (weak, nonatomic) IBOutlet LABackgroundView *rightView;
@property (weak, nonatomic) IBOutlet LABackgroundView *contentBarView;

- (void)setLeftViewVisible:(BOOL)leftViewVisible withWidth:(CGFloat)width animated:(BOOL)animated completionHandler:(void (^)(void))completionHandler;
- (void)setBottomViewVisible:(BOOL)bottomViewVisible withHeight:(CGFloat)height animated:(BOOL)animated completionHandler:(void (^)(void))completionHandler;
- (void)setRightViewVisible:(BOOL)rightViewVisible withWidth:(CGFloat)width animated:(BOOL)animated completionHandler:(void (^)(void))completionHandler;

@end
