//
//  LAMenu.h
//  LAAdditions
//
//  Created by Cyril Anger on 28/08/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAObserver.h>

@class LAMenu;

typedef void (^LAMenuBlock)(LAMenu *menu, NSMenuItem *item, id object);
typedef void (^LAMenuContentChangedBlock)(LAMenu *menu);

@interface LAMenu : NSMenu <LAObserverDelegate>

@property (strong, nonatomic) IBInspectable NSString *titleKeyPath;
@property (strong, nonatomic) IBInspectable NSString *imageKeyPath;
@property (nonatomic) IBInspectable BOOL canSelectGroups;
@property (nonatomic) IBInspectable NSInteger contentPlacementTag;
@property (strong, nonatomic) IBInspectable NSString *nullPlaceholder;
@property (strong, nonatomic) IBInspectable NSImage *nullPlaceholderImage;
@property (strong, nonatomic, readonly) NSMenuItem *nullPlaceholderItem;
@property (strong, nonatomic, readonly) NSMenu *submenuTemplate;
@property (strong, nonatomic) LAObserver *observer;
@property (strong, nonatomic) NSArray *objects;
@property (copy, nonatomic) LAMenuBlock block;
@property (copy, nonatomic) LAMenuContentChangedBlock contentChangedBlock;

- (id)initWithItems:(NSArray *)items contentPlacementTag:(NSInteger)contentPlacementTag;
- (BOOL)isContent:(NSMenuItem *)item;
- (void)prepareMenu;

@end
