//
//  LANumberFormatter.h
//  LAAdditions
//
//  Created by Cyril Anger on 09/02/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface LANumberFormatter : NSNumberFormatter

@property (nonatomic) BOOL guessesSeparators;
@property (strong, nonatomic) id <NSDecimalNumberBehaviors> decimalNumberBehavior;

+ (NSString *)formatValue:(NSDecimalNumber *)value;
+ (NSString *)formatValue:(NSDecimalNumber *)value withMaximumFractionDigits:(NSInteger)maximumFractionDigits;
+ (NSDecimalNumber *)parseString:(NSString *)string;
+ (NSDecimalNumber *)parseString:(NSString *)string withBehavior:(id <NSDecimalNumberBehaviors>)decimalNumberBehavior;

- (void)currentLocaleDidChange:(NSNotification *)notification;
- (NSMutableArray *)componentsFromString:(NSString *)string;
- (NSDecimalNumber *)evaluateObject:(id)object;
- (NSDecimalNumber *)evaluateString:(NSString *)string;
- (NSDecimalNumber *)evaluateArray:(NSMutableArray *)array;

@end
