//
//  LAObject.h
//  LAAdditions
//
//  Created by Cyril Anger on 03/08/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol LAObject <NSObject>

@property (strong, nonatomic, readonly) NSString *ID;

@optional

- (void)delete;
- (instancetype)duplicate;

@end

typedef id (^LAMasterObjectResultsBlock)(NSArray *objects, NSArray *results);

@interface LAMasterObject : NSObject <LAObject>

- (instancetype)initWithObjects:(NSArray *)objects;
@property (strong, nonatomic) NSArray *objects;
- (BOOL)duplicatesArgumentForKey:(NSString *)key;
- (void)setDuplicatesArgument:(BOOL)duplicatesArgument forKey:(NSString *)key;
- (void)setResultsBlocks:(LAMasterObjectResultsBlock)resultsBlock forKey:(NSString *)key;
- (BOOL)cachesResultForKey:(NSString *)key;
- (void)setCachesResult:(BOOL)cachesResult forKey:(NSString *)key;

@end
