//
//  LAObjectAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 21/12/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

extern void RunOnThread(NSThread *thread, BOOL waitUntilDone, void (^block)(void));
extern void SwizzleMethod(Class class, SEL selector, SEL newSelector, id block);
extern void SwizzleClassMethod(Class class, SEL selector, SEL newSelector, id block);
extern Class CommonClass(Class class1, Class class2);

@interface LAPropertyBinder : NSObject

@property (strong, nonatomic) id observedObject;
@property (copy, nonatomic) void (^updateObservedObjectBlock)(id observedObject, NSString *observedKeyPath, id value);
- (void)updateObservedObject;

@end

@interface NSObject (LAObjectAdditions)

- (void)bindProperty:(NSString *)keyPath toObject:(id)observedObject withKeyPath:(NSString *)observedKeyPath valueTransformerName:(NSString *)valueTransformerName;
- (void)unbindProperty:(NSString *)keyPath;
- (LAPropertyBinder *)propertyBinder:(NSString *)keyPath;
- (void)notifyChangeValueForKey:(NSString *)key;
- (NSString *)validUniqueValue:(NSString *)value forKeyPath:(NSString *)keyPath inArray:(NSArray *)array;
- (NSString *)validUniqueValue:(NSString *)value forKeyPath:(NSString *)keyPath inArray:(NSArray *)array withFormat:(NSString *)format pattern:(NSString *)pattern;
- (void)perform;

@end
