//
//  LAObserverPopUpButton.h
//  LAAdditions
//
//  Created by Cyril Anger on 24/07/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAPopUpButton.h>
#import <LAAdditions/LAObserver.h>

@class LAObserverPopUpButtonCell, LAObserverPopUpButton;

typedef void (^LAObserverPopUpButtonCellBlock)(LAObserverPopUpButtonCell *cell, id object);
typedef void (^LAObserverPopUpButtonBlock)(LAObserverPopUpButton *button, id object);

@interface LAObserverPopUpButtonCell : LAPopUpButtonCell <NSMenuDelegate, LAObserverDelegate>

@property (strong, nonatomic) IBInspectable NSString *titleKeyPath;
@property (strong, nonatomic) IBInspectable NSString *imageKeyPath;
@property (nonatomic) IBInspectable BOOL canSelectGroups;
@property (nonatomic) IBInspectable NSInteger contentPlacementTag;
@property (strong, nonatomic) IBInspectable NSString *multipleValuesPlaceholder;
@property (strong, nonatomic) IBInspectable NSString *noSelectionPlaceholder;
@property (strong, nonatomic) IBInspectable NSString *nullPlaceholder;
@property (strong, nonatomic) IBInspectable NSImage *nullPlaceholderImage;
@property (strong, nonatomic) LAObserver *observer;
@property (strong, nonatomic) NSArray *objects;
@property (strong, nonatomic) id selectedRepresentedObject;
@property (copy, nonatomic) LAObserverPopUpButtonCellBlock block;

@end

@interface LAObserverPopUpButton : LAPopUpButton <LAObserverDelegate>

@property (strong, nonatomic) IBInspectable NSString *titleKeyPath;
@property (strong, nonatomic) IBInspectable NSString *imageKeyPath;
@property (nonatomic) IBInspectable BOOL canSelectGroups;
@property (nonatomic) IBInspectable NSInteger contentPlacementTag;
@property (strong, nonatomic) IBInspectable NSString *multipleValuesPlaceholder;
@property (strong, nonatomic) IBInspectable NSString *noSelectionPlaceholder;
@property (strong, nonatomic) IBInspectable NSString *nullPlaceholder;
@property (strong, nonatomic) IBInspectable NSImage *nullPlaceholderImage;
@property (strong, nonatomic) LAObserver *observer;
@property (strong, nonatomic) NSArray *objects;
@property (strong, nonatomic) id selectedRepresentedObject;
@property (copy, nonatomic) LAObserverPopUpButtonBlock block;

@end
