//
//  LAOrderedMap.h
//  LAAdditions
//
//  Created by Cyril Anger on 08/03/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface LAOrderedMap : NSObject

@property (strong, nonatomic, readonly) NSMutableArray *keys;
@property (strong, nonatomic, readonly) NSMutableArray *objects;

+ (LAOrderedMap *)orderedMapWithArray:(NSArray *)array keyPath:(NSString *)keyPath;

- (NSUInteger)count;
- (id)objectForKey:(id)key;
- (id)objectForKeyedSubscript:(id)key;
- (void)insertObject:(id)object atIndex:(NSUInteger)index forKey:(id)key;
- (void)addObject:(id)object forKey:(id)key;
- (void)removeObjectForKey:(id)key;
- (void)removeAllObjects;

@end
