//
//  LAParameter.h
//  LAAdditions
//
//  Created by Cyril Anger on 01/10/11.
//  Copyright (c) 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LADatabaseObject.h>
#import <LAAdditions/LADuration.h>
#import <LAAdditions/LAConstant.h>

@interface LAParameter : LADatabaseObject

@property (strong, nonatomic) id value;

@end

@interface LAStringParameter : LAParameter

@property (strong, nonatomic) NSString *string;

@end

@interface LADateParameter : LAParameter

+ (NSArray *)types;
@property (strong, nonatomic) NSString *type;
@property (strong, nonatomic) NSDate *date;
+ (NSArray *)operators;
@property (strong, nonatomic) NSString *operator;
@property (strong, nonatomic) LADuration *duration;

@end

@interface LANumberParameter : LAParameter

@property (strong, nonatomic) NSDecimalNumber *number;

@end

@interface LAColorParameter : LAParameter

@property (strong, nonatomic) LAColor *color;

@end

@interface LAConstantParameter : LAParameter

@property (strong, nonatomic) LAConstant *constant;

@end

@interface LAReferenceParameter : LAParameter

@property (strong, nonatomic) LADatabaseObject *object;

@end
