//
//  LAPartsView.h
//  LAAdditions
//
//  Created by Cyril Anger on 28/08/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LAViewAdditions.h>
#import <LAAdditions/LAFontAdditions.h>

@protocol LAPart <NSObject>

@property (strong, nonatomic, readonly) NSDecimalNumber *ratio;

@end

IB_DESIGNABLE
@interface LAPartsView : LAControl

@property (getter = isVertical, nonatomic) IBInspectable BOOL vertical;
@property (nonatomic, readonly) LAColor *borderColor;
@property (nonatomic, readonly) CGBlendMode borderBlendMode;
@property (getter = isBordered, nonatomic) IBInspectable BOOL bordered;
@property (nonatomic) IBInspectable BOOL backgroundDimsWhenDisabled;
@property (strong, nonatomic) IBInspectable LAFont *font;
@property (getter = isClicked, nonatomic, readonly) BOOL clicked;
@property (nonatomic, readonly) NSArray *observedKeyPaths;
@property (copy, nonatomic) NSArray *parts;
@property (nonatomic) BOOL usesCache;
@property (strong, nonatomic) LAPartsView *popupView;
@property (copy, nonatomic) id (^createAccessoryControllerBlock)(id view);

#if TARGET_OS_IPHONE
@property (weak, nonatomic) IBOutlet UIViewController *parentController;
#endif

- (void)invalidateCache;
- (void)drawBackgroundForPart:(id <LAPart>)part inRect:(LARect)rect;
- (LAColor *)colorForPart:(id <LAPart>)part;
- (LAImage *)iconForPart:(id <LAPart>)part;
- (NSString *)titleForPart:(id <LAPart>)part;
- (void)drawPart:(id <LAPart>)part inRect:(LARect)rect;
- (void)drawSeparatorAtPoint:(CGFloat)p;
#if !TARGET_OS_IPHONE
- (NSString *)toolTipForPart:(id <LAPart>)part;
#endif
- (LAPartsView *)createPopupView;

@end
