//
//  LAPieView.h
//  LAAdditions
//
//  Created by Cyril Anger on 09/06/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAViewAdditions.h>

@protocol LAPieViewDataSource;

@interface LAPiePart : NSObject

@property (nonatomic, readonly) NSUInteger index;
@property (nonatomic, readonly) CGFloat percentage;
@property (strong, nonatomic, readonly) LAColor *color;
@property (strong, nonatomic, readonly) NSString *title;

@end

@interface LAPieView : LAControl

@property (strong, nonatomic, readonly) NSArray *parts;
@property (strong, nonatomic, readonly) LAPiePart *selectedPart;
@property (nonatomic) BOOL usesCache;

@property (weak, nonatomic) IBOutlet id <LAPieViewDataSource> dataSource;

- (void)reloadData;

@end

#if TARGET_OS_IPHONE

@interface LAPieView () <UIViewControllerPreviewingDelegate>

@end

#endif

@protocol LAPieViewDataSource <NSObject>

@required

- (NSUInteger)numberOfItemsInPieView:(LAPieView *)pieView;
- (CGFloat)pieView:(LAPieView *)pieView percentageForItem:(NSUInteger)index;

@optional

- (LAColor *)pieView:(LAPieView *)pieView colorForItem:(NSUInteger)index;
- (NSString *)pieView:(LAPieView *)pieView titleForItem:(NSUInteger)index;
- (void)pieView:(LAPieView *)pieView didSelectItem:(NSUInteger)index;
- (void)pieView:(LAPieView *)pieView doubleClickOnItem:(NSUInteger)index;
#if TARGET_OS_IPHONE
- (UIViewController *)pieView:(LAPieView *)pieView previewViewControllerForItem:(NSUInteger)index;
- (void)pieView:(LAPieView *)pieView commitPreviewViewController:(UIViewController *)viewController;
#else
- (NSViewController *)pieView:(LAPieView *)pieView previewViewControllerForItem:(NSUInteger)index;
#endif

@end
