//
//  LAPopUpWindow.h
//  LAAdditions
//
//  Created by Cyril Anger on 24/07/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef void (^LAPopUpWindowDrawingBlock)(NSView *view, NSRect rect);
typedef void (^LAPopUpWindowClosingBlock)(NSWindow *window);

@interface LAPopUpWindow : NSWindow <NSWindowDelegate>

@property (copy, nonatomic, readonly) LAPopUpWindowDrawingBlock drawingBlock;
@property (strong, nonatomic) NSViewController *accessoryViewController;

- (id)initWithView:(NSView *)view drawingBlock:(LAPopUpWindowDrawingBlock)drawingBlock;
- (void)showInParentWindow:(NSWindow *)parentWindow usingBlock:(LAPopUpWindowClosingBlock)closingBlock;
- (void)setAccessoryViewController:(NSViewController *)accessoryViewController animated:(BOOL)animated;

@end
