//
//  LARequestsMap.h
//  LAAdditions
//
//  Created by Cyril Anger on 08/03/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef void (^LARequestBlock)(id object);

@interface LARequestsMap : NSObject <NSFastEnumeration>

- (id)initWithRequestsMap:(LARequestsMap *)requestsMap;
- (NSUInteger)count;
- (NSArray *)allKeys;
- (NSArray *)allValues;
- (BOOL)hasRequestsForKey:(id)key;
- (void)requestObjectForKey:(id)key usingBlock:(LARequestBlock)block;
- (id)objectForKey:(id)key;
- (id)objectForKeyedSubscript:(id)key;
- (void)setObject:(id)object forKey:(id)key;
- (void)setObject:(id)object forKeyedSubscript:(id)key;
- (void)removeObjectForKey:(id)key;
- (void)removeAllObjects;
- (void)removeAllRequests;

@end
