//
//  LARule.h
//  PocketMoney
//
//  Created by Cyril Anger on 28/03/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LACondition.h>
#import <LAAdditions/LAImageAdditions.h>

@protocol LAAbstractRuleParent <NSObject>

@property (strong, nonatomic) NSMutableArray *rules;
- (void)insertRules:(NSArray *)rules atIndexes:(NSIndexSet *)indexes;
- (void)removeRulesAtIndexes:(NSIndexSet *)indexes;
- (void)addRules:(NSArray *)rules;
- (void)removeRules:(NSArray *)rules;
- (void)sortRulesAlphabetically;

@end

@interface LAAbstractRule : LADatabaseObject

@property (getter = isLeaf, nonatomic, readonly) BOOL leaf;
@property (weak, nonatomic) LADatabaseObject <LAAbstractRuleParent> *parent;
@property (nonatomic) long long index;
@property (strong, nonatomic) NSString *name;
@property (readonly) NSString *fullName;
@property (readonly) LAImage *icon;
@property (nonatomic) BOOL active;

@end

@interface LARule : LAAbstractRule

@property (strong, nonatomic) LACompoundCondition *condition;
@property (strong, nonatomic) NSMutableArray *actions;
- (void)insertActions:(NSArray *)actions atIndexes:(NSIndexSet *)indexes;
- (void)removeActionsAtIndexes:(NSIndexSet *)indexes;
- (void)addActions:(NSArray *)actions;
- (void)removeActions:(NSArray *)actions;

@end

@interface LARulesGroup : LAAbstractRule <LAAbstractRuleParent>

@end

@interface LAAction : LADatabaseObject <LATemplateControlledObject>

@property (weak, nonatomic) LARule *rule;
@property (nonatomic) long long index;
@property (strong, nonatomic) NSString *name;
@property (strong, nonatomic) LAParameter *parameter1;
@property (strong, nonatomic) LAParameter *parameter2;
@property (strong, nonatomic) LAParameter *parameter3;
@property (strong, nonatomic) LAParameter *parameter4;
@property (strong, nonatomic) LAParameter *parameter5;

@end
