//
//  LASecureTextField.h
//  LAAdditions
//
//  Created by Cyril Anger on 05/04/13.
//  Copyright (c) 2013 LyricApps. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <LAAdditions/LAStructures.h>
#import <LAAdditions/LAColorAdditions.h>

@class LASecureTextFieldCell, LASecureTextField;

typedef void (^LASecureTextFieldCellBlock)(LASecureTextFieldCell *cell, NSString *string, id object);
typedef void (^LASecureTextFieldBlock)(LASecureTextField *field, NSString *string, id object);

@interface LASecureTextFieldCell : NSSecureTextFieldCell

@property (getter = isEditing, nonatomic) BOOL editing;
@property (getter = isEdited, nonatomic) BOOL edited;
@property (strong, nonatomic) NSShadow *textShadow;
@property (strong, nonatomic) LAColor *textShadowColor;
@property (nonatomic) LASize textShadowOffset;
@property (nonatomic) CGFloat textShadowBlurRadius;
@property (copy, nonatomic) LASecureTextFieldCellBlock block;

- (NSSize)rawCellSize;

@end

@interface LASecureTextField : NSSecureTextField

@property (getter = isEditing, nonatomic, readonly) BOOL editing;
@property (strong, nonatomic) NSShadow *textShadow;
@property (strong, nonatomic) LAColor *textShadowColor;
@property (nonatomic) LASize textShadowOffset;
@property (nonatomic) CGFloat textShadowBlurRadius;
@property (copy, nonatomic) LASecureTextFieldBlock block;

@property (weak, nonatomic) IBOutlet NSView *leftAccessoryView;
@property (weak, nonatomic) IBOutlet NSView *rightAccessoryView;

- (void)sendAction;

@end
