//
//  LAStringAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 07/12/05.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LAColorAdditions.h>
#import <LAAdditions/LAFontAdditions.h>
#import <LAAdditions/LAImageAdditions.h>

@interface NSString (LAStringAdditions)

+ (NSString *)stringWithCharacter:(NSString *)character length:(NSUInteger)length;
+ (NSString *)uniqueID;
+ (NSString *)temporaryPathWithExtension:(NSString *)extension;

- (NSString *)localizedString;
- (NSString *)libraryLocalizedString;
- (NSString *)MD5;
- (NSString *)SHA1;
- (NSString *)SHA256;
- (NSString *)HMACMD5WithKey:(NSString *)key;
- (NSComparisonResult)numericCompare:(NSString *)string;
- (NSComparisonResult)compareToVersion:(NSString *)latestVersion;
- (NSString *)firstLetterCapitalizedString;
- (NSString *)firstLetterUncapitalizedString;
- (NSString *)URLEncodedStringUsingEncoding:(NSStringEncoding)encoding;
- (NSString *)URLDecodedStringUsingEncoding:(NSStringEncoding)encoding;
- (NSDictionary *)URLQueryParameters;
- (BOOL)isValidXMLTag:(NSString **)validXMLTag;
- (NSString *)stringForEmbeddingInHTML;
- (NSString *)stringByDecodingHTMLEntities;
- (NSTextCheckingResult *)patternMatch:(NSString *)pattern;
- (NSString *)stringByReplacingOccurrencesOfPattern:(NSString *)pattern withString:(NSString *)template;
- (NSArray *)CSVRowsWithSeparator:(NSString *)separator hasHeader:(BOOL)hasHeader createHeader:(BOOL)createHeader header:(NSArray **)header;
- (NSArray *)objectPathComponents;
- (NSString *)firstObjectPathComponent;
- (NSString *)stringByDeletingFirstObjectPathComponent;
- (NSString *)stringByAppendingObjectPathComponent:(NSString *)string;
- (NSString *)stringByStandardizingObjectPathComponents;
- (LASize)singleLineSizeWithFont:(LAFont *)font;
- (LASize)multiLinesSizeWithFont:(LAFont *)font constrainedToSize:(LASize)size;
- (NSAttributedString *)attributedStringWithFont:(LAFont *)font color:(LAColor *)color lineBreakMode:(NSLineBreakMode)lineBreakMode alignment:(NSTextAlignment)alignment shadowColor:(LAColor *)shadowColor shadowOffset:(LASize)shadowOffset shadowBlur:(CGFloat)shadowBlur;
- (void)drawInRect:(LARect)rect withFont:(LAFont *)font color:(LAColor *)color alignment:(NSTextAlignment)alignment;
- (void)drawInRect:(LARect)rect withFont:(LAFont *)font color:(LAColor *)color lineBreakMode:(NSLineBreakMode)lineBreakMode alignment:(NSTextAlignment)alignment shadowColor:(LAColor *)shadowColor shadowOffset:(LASize)shadowOffset shadowBlur:(CGFloat)shadowBlur;
- (void)drawInRect:(LARect)rect withIcon:(LAImage *)icon size:(LASize)iconSize insets:(LAEdgeInsets)insets font:(LAFont *)font color:(LAColor *)color lineBreakMode:(NSLineBreakMode)lineBreakMode alignment:(NSTextAlignment)alignment shadowColor:(LAColor *)shadowColor shadowOffset:(LASize)shadowOffset shadowBlur:(CGFloat)shadowBlur;
- (void)drawMultilinesInRect:(LARect)rect withFont:(LAFont *)font color:(LAColor *)color alignment:(NSTextAlignment)alignment;
- (void)drawMultilinesInRect:(LARect)rect withFont:(LAFont *)font color:(LAColor *)color lineBreakMode:(NSLineBreakMode)lineBreakMode alignment:(NSTextAlignment)alignment shadowColor:(LAColor *)shadowColor shadowOffset:(LASize)shadowOffset shadowBlur:(CGFloat)shadowBlur;

@end

@interface LAURLToStringTransformer : NSValueTransformer

@end
