//
//  LAStringEncoding.h
//  LAAdditions
//
//  Created by Cyril Anger on 30/05/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LAConstant.h>

@interface LAStringEncoding : LAConstant

@property (strong, nonatomic, readonly) NSString *XMLEncoding;

+ (LAStringEncoding *)ASCIIStringEncoding;
+ (LAStringEncoding *)MacOSRomanStringEncoding;
+ (LAStringEncoding *)ISOLatin1StringEncoding;
+ (LAStringEncoding *)ISOLatin2StringEncoding;
+ (LAStringEncoding *)ISOLatin3StringEncoding;
+ (LAStringEncoding *)ISOLatin4StringEncoding;
+ (LAStringEncoding *)ISOLatinCyrillicStringEncoding;
+ (LAStringEncoding *)ISOLatinArabicStringEncoding;
+ (LAStringEncoding *)ISOLatinGreekStringEncoding;
+ (LAStringEncoding *)ISOLatinHebrewStringEncoding;
+ (LAStringEncoding *)ISOLatin5StringEncoding;
+ (LAStringEncoding *)ISOLatin6StringEncoding;
+ (LAStringEncoding *)ISOLatinThaiStringEncoding;
+ (LAStringEncoding *)ISOLatin7StringEncoding;
+ (LAStringEncoding *)ISOLatin8StringEncoding;
+ (LAStringEncoding *)ISOLatin9StringEncoding;
+ (LAStringEncoding *)ISOLatin10StringEncoding;
+ (LAStringEncoding *)UTF8StringEncoding;
+ (LAStringEncoding *)UTF16BigEndianStringEncoding;
+ (LAStringEncoding *)UTF16LittleEndianStringEncoding;
+ (LAStringEncoding *)WindowsCP1250StringEncoding;
+ (LAStringEncoding *)WindowsCP1251StringEncoding;
+ (LAStringEncoding *)WindowsCP1252StringEncoding;
+ (LAStringEncoding *)WindowsCP1253StringEncoding;
+ (LAStringEncoding *)WindowsCP1254StringEncoding;
+ (LAStringEncoding *)ShiftJISStringEncoding;
+ (LAStringEncoding *)BIG5StringEncoding;
+ (LAStringEncoding *)BIG5HKSCSStringEncoding;
+ (LAStringEncoding *)GB2312StringEncoding;
+ (LAStringEncoding *)GBKStringEncoding;
+ (LAStringEncoding *)GB18030StringEncoding;
+ (LAStringEncoding *)EUCCNStringEncoding;
+ (LAStringEncoding *)HZGB2312StringEncoding;
+ (LAStringEncoding *)ISO2022CNStringEncoding;

- (id)initWithName:(NSString *)name value:(NSInteger)value XMLEncoding:(NSString *)XMLEncoding;

@end
