//
//  LATCPClient.h
//  LAAdditions
//
//  Created by Cyril Anger on 17/04/08.
//  Copyright 2008 Angeman. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LATCPServer.h>

@protocol LATCPClientDelegate;

@interface LATCPClient : NSObject <NSNetServiceBrowserDelegate, NSNetServiceDelegate>

@property (weak, nonatomic) Class connectionClass;
@property (strong, nonatomic) NSString *protocol;
@property (strong, nonatomic, readonly) NSMutableArray *netServices;
@property (strong, nonatomic, readonly) LATCPServer *server;
@property (weak, nonatomic) id delegate;

- (void)createConnection:(NSNetService *)netService;
- (void)startServerWithName:(NSString *)name;
- (void)stopServer;

@end

@protocol LATCPClientDelegate <NSObject>

@optional

- (void)client:(LATCPClient *)client willTryToResolveNetService:(NSNetService *)netService;
- (void)client:(LATCPClient *)client didFailToResolveNetService:(NSNetService *)netService;

@required

- (void)client:(LATCPClient *)client didCreateConnection:(LATCPConnection *)connection toNetService:(NSNetService *)netService;

@end

@interface NSNetService (LATCPClientAdditions)

@property (readonly, nonatomic) NSString *ID;

@end
