//
//  LATCPServer.h
//  LAAdditions
//
//  Created by Cyril Anger on 17/04/08.
//  Copyright 2008 Angeman. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CFNetwork/CFNetwork.h>
#import <sys/socket.h>

#import <LAAdditions/LATCPConnection.h>

@interface LATCPServer : NSObject

@property (weak, nonatomic) Class connectionClass;
@property (nonatomic) NSUInteger port;
@property (getter = isRunning, nonatomic, readonly) BOOL running;
@property (readonly) NSString *name;
@property (strong, nonatomic, readonly) NSMutableArray *connections;
@property (weak, nonatomic) id delegate;

- (id)initWithPort:(NSUInteger)port;
- (BOOL)start;
- (void)stop;
- (BOOL)enableBonjourWithName:(NSString *)name protocol:(NSString *)protocol;
- (void)disableBonjour;
- (void)addConnection:(LATCPConnection *)connection;
- (void)removeConnection:(LATCPConnection *)connection;
- (void)checkAuthorizationOfConnection:(LATCPConnection *)connection withParentController:(id)parentController acceptBlock:(void (^)(void))acceptBlock cancelBlock:(void (^)(void))cancelBlock;

@end
