//
//  LATableCellView.h
//  LAAdditions
//
//  Created by Cyril Anger on 14/04/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <LAAdditions/LABadgeView.h>

@interface LATableCellView : NSTableCellView

@property (nonatomic, readonly) CGFloat rowHeight;
@property (strong, nonatomic) IBInspectable NSString *imageKeyPath;
@property (strong, nonatomic) IBInspectable NSString *valueKeyPath;
@property (getter = isEnabled, nonatomic) BOOL enabled;
@property (nonatomic, readonly) NSArray *badges;

@property (strong, nonatomic) IBOutlet NSLayoutConstraint *imageTrailingConstraint;
@property (weak, nonatomic) IBOutlet LABadgeView *badgeView;

- (void)userInterfaceSizeDidChange;

@end

@interface LAStandardTableCellView : LATableCellView

@property (weak, nonatomic) IBOutlet NSControl *control;

+ (CGFloat)rowHeight;

@end
