//
//  LATemplate.h
//  LAAdditions
//
//  Created by Cyril Anger on 14/04/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <LAAdditions/LAObject.h>
#import <LAAdditions/LAOrderedMap.h>
#import <LAAdditions/LAViewAdditions.h>

@interface LATemplate : NSObject <LAObject>

- (id)initWithName:(NSString *)name;
@property (strong, nonatomic, readonly) NSString *name;
@property (readonly) NSString *title;
+ (NSString *)objectTemplateNameKeyPath;
+ (NSSet *)objectKeyPathsToObserve;
- (void)updateObject:(id)object;
- (LAOrderedMap *)widgetsForObject:(id)object previousWidgets:(LAOrderedMap *)previousWidgets;
- (NSArray *)activeKeysForObject:(id)object;
- (id)createWidgetForKey:(NSString *)key object:(id)object;
- (void)updateWidget:(id)widget forKey:(NSString *)key object:(id)object;

@end

@protocol LATemplateControlledObject <NSObject>

+ (Class)templateClass;

@end

#if TARGET_OS_IPHONE

@interface UIButton (LATemplateAdditions)

- (void)applyTemplateStyle;

@end

#endif
