//
//  LATextField.h
//  LAAdditions
//
//  Created by Cyril Anger on 14/01/07.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <LAAdditions/LAStructures.h>
#import <LAAdditions/LAColorAdditions.h>

@class LATextFieldCell, LATextField;

typedef void (^LATextFieldCellBlock)(LATextFieldCell *cell, NSString *string, id object);
typedef void (^LATextFieldBlock)(LATextField *field, NSString *string, id object);

@interface LATextFieldCell : NSTextFieldCell

@property (getter = isEditing, nonatomic) BOOL editing;
@property (getter = isEdited, nonatomic) BOOL edited;
@property (strong, nonatomic) NSShadow *textShadow;
@property (strong, nonatomic) LAColor *textShadowColor;
@property (nonatomic) LASize textShadowOffset;
@property (nonatomic) CGFloat textShadowBlurRadius;
@property (copy, nonatomic) LATextFieldCellBlock block;

- (NSSize)rawCellSize;

@end

@interface LATextField : NSTextField

@property (getter = isEditing, nonatomic, readonly) BOOL editing;
@property (strong, nonatomic) NSShadow *textShadow;
@property (strong, nonatomic) LAColor *textShadowColor;
@property (nonatomic) LASize textShadowOffset;
@property (nonatomic) CGFloat textShadowBlurRadius;
@property (copy, nonatomic) LATextFieldBlock block;

@property (weak, nonatomic) IBOutlet NSView *leftAccessoryView;
@property (weak, nonatomic) IBOutlet NSView *rightAccessoryView;

- (void)sendAction;

@end
