//
//  LATreeNode.h
//  LAAdditions
//
//  Created by Cyril Anger on 24/03/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <LAAdditions/LATableCellView.h>

@class LATreeNodesDataSource;

@interface LATreeNode : NSObject

@property (weak, nonatomic) LATreeNodesDataSource *parentDataSource;
@property (weak, nonatomic, readonly) LATreeNode *parentNode;
@property (nonatomic, readonly) NSArray *allParentNodes;
@property (weak, nonatomic) LATreeNode *previousNode;
@property (weak, nonatomic) LATreeNode *nextNode;
@property (strong, nonatomic, readonly) NSMutableArray *nodes;
@property (nonatomic, readonly) NSArray *descendantNodes;
@property (nonatomic, readonly) NSArray *visibleDescendantNodes;
@property (strong, nonatomic, readonly) id representedObject;
@property (getter = isLeaf, nonatomic, readonly) BOOL leaf;
@property (getter = isExpanded, nonatomic) BOOL expanded;
@property (getter = isSelected, nonatomic) BOOL selected;
@property (strong, nonatomic, readonly) NSString *ID;
@property (nonatomic, readonly) NSString *fullID;
@property (strong, nonatomic) LATableCellView *view;
@property (strong, nonatomic) NSString *viewIdentifier;

- (id)initLeaf:(BOOL)leaf withRepresentedObject:(id)representedObject ID:(NSString *)ID view:(LATableCellView *)view;
- (id)initLeaf:(BOOL)leaf withRepresentedObject:(id)representedObject ID:(NSString *)ID viewIdentifier:(NSString *)viewIdentifier;
- (void)insertNodes:(NSArray *)nodes atIndexes:(NSIndexSet *)indexes;
- (void)removeNodesAtIndexes:(NSIndexSet *)indexes;
- (NSUInteger)numberOfNodes;
- (LATreeNode *)nodeAtIndex:(NSUInteger)index;

@end
