//
//  LAURLConnection.h
//  LAAdditions
//
//  Created by Cyril Anger on 18/11/04.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#else
#import <AppKit/AppKit.h>
#endif

typedef void (^LAURLConnectionBlock)(id connection, BOOL error);

@interface LAURLConnection : NSURLConnection <NSURLConnectionDelegate, NSURLConnectionDataDelegate>

@property (getter = isCanceled, nonatomic, readonly) BOOL canceled;
@property (strong, nonatomic, readonly) NSURLRequest *request;
@property (strong, nonatomic, readonly) NSURLResponse *response;
@property (strong, nonatomic, readonly) NSMutableData *data;
#if TARGET_OS_IPHONE
@property (strong, nonatomic, readonly) UIProgressView *progressBar;
@property (strong, nonatomic, readonly) UIActivityIndicatorView *activityIndicator;
#else
@property (strong, nonatomic, readonly) NSProgressIndicator *progressBar;
@property (strong, nonatomic, readonly) NSProgressIndicator *activityIndicator;
#endif

+ (void)setMaxNumberOfConcurrentConnections:(NSUInteger)maxNumberOfConcurrentConnections;

- (id)initWithRequest:(NSURLRequest *)request completionHandler:(LAURLConnectionBlock)completionHandler;
- (void)startImmediately;

@end
