//
//  LAURLDownload.h
//  LAAdditions
//
//  Created by Cyril Anger on 03/03/2016.
//  Copyright © 2016 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef void (^LAURLDownloadBlock)(id download, BOOL error);

@interface LAURLDownload : NSObject

@property (strong, nonatomic, readonly) NSURLRequest *request;
@property (strong, nonatomic, readonly) NSString *path;
@property (nonatomic, readonly) BOOL downloaded;
@property (nonatomic, readonly) unsigned long long downloadSize;
@property (nonatomic, readonly) unsigned long long downloadedSize;
@property (nonatomic, readonly) float progress;
@property (copy, nonatomic) void (^progressHandler)(float progress);

+ (void)setMaxNumberOfConcurrentConnections:(NSUInteger)maxNumberOfConcurrentConnections;

- (id)initWithRequest:(NSURLRequest *)request path:(NSString *)path completionHandler:(LAURLDownloadBlock)completionHandler;
- (void)start;
- (void)cancel;

@end
