//
//  LAURLRequestAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 12/06/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSURLRequest (LAURLRequestAdditions)

+ (id)requestWithURL:(NSURL *)URL GETParameters:(NSDictionary *)parameters;
+ (id)requestWithURL:(NSURL *)URL URLEncodedPOSTParameters:(NSDictionary *)parameters;
+ (id)requestWithURL:(NSURL *)URL POSTParameters:(NSDictionary *)parameters;
+ (id)requestWithURL:(NSURL *)URL POSTParameters:(NSDictionary *)parameters encoding:(NSStringEncoding)encoding;

@end

@interface NSMutableURLRequest (LAURLRequestAdditions)

- (void)addBasicAuthenticationForUser:(NSString *)user password:(NSString *)password;

@end

@interface LAURLRequestFileParameter : NSObject

@property (strong, nonatomic) NSData *data;
@property (strong, nonatomic) NSString *name;
@property (strong, nonatomic) NSString *contentType;

- (id)initWithData:(NSData *)data name:(NSString *)name contentType:(NSString *)contentType;

@end
