//
//  LAWindowAdditions.h
//  LAAdditions
//
//  Created by Cyril Anger on 20/06/11.
//  Copyright 2011 LyricApps. All rights reserved.
//

#import <AppKit/AppKit.h>

#import <LAAdditions/LAStructures.h>

@interface NSWindow (LAWindowAdditions)

@property LAEdgeInsets contentInsets;
@property (readonly) LARect contentFrame;
@property (getter = isOutsideScreen, readonly) BOOL outsideScreen;
@property (getter = isToolbarEnabled) BOOL toolbarEnabled;

- (NSPoint)convertPointToScreen:(NSPoint)point;
- (NSPoint)convertPointFromScreen:(NSPoint)point;
- (void)endCurrentEditingInView:(NSView *)view;
- (NSInteger)runModal;
- (IBAction)abortModal:(id)sender;
- (IBAction)stopModal:(id)sender;

@end
