//
//  LAXMLNode.h
//  LAAdditions
//
//  Created by Cyril Anger on 06/05/12.
//  Copyright (c) 2012 LyricApps. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef struct _xmlNode *xmlNodePtr;

@interface LAXMLNode : NSObject <NSCoding>

@property (weak, nonatomic, readonly) LAXMLNode *parent;
@property (copy, nonatomic) NSString *name;
@property (copy, nonatomic) NSString *text;
@property (strong, nonatomic) NSMutableDictionary *attributes;
@property (strong, nonatomic) NSMutableArray *children;
@property (nonatomic, readonly) xmlNodePtr node;
@property (readonly) NSString *nodePath;

+ (id)nodeWithNode:(xmlNodePtr)node;

- (id)initWithName:(NSString *)name attributes:(NSDictionary *)attributes;
- (NSString *)attributeNamed:(NSString *)name;
- (void)addChild:(LAXMLNode *)child;
- (void)removeChild:(LAXMLNode *)child;
- (LAXMLNode *)childNamed:(NSString *)name;
- (NSArray *)childrenNamed:(NSString *)name;
- (LAXMLNode *)nodeWithPath:(NSString *)path createIfNeeded:(BOOL)create;
- (LAXMLNode *)addNodeWithPath:(NSString *)path;
- (NSString *)valueForPath:(NSString *)path;
- (void)setValue:(NSString *)value forPath:(NSString *)path;
- (void)enumerateAllChildrenUsingBlock:(void (^)(LAXMLNode *node, NSString *path, BOOL *stop))block;

@end
