CREATE TABLE LAMetadata (
	"version" TEXT NOT NULL,
	"password" TEXT,
	"localParameters" TEXT
);

CREATE TABLE LADeletedID (
	"ID" TEXT UNIQUE NOT NULL,
	"date" TEXT
);

CREATE TABLE LASynchronizationHandler (
	"description" TEXT NOT NULL,
	"identifier" TEXT,
	"active" INTEGER NOT NULL,
	"lastSynchronizationDate" TEXT
);

-- Parameters

CREATE TABLE LAParameter (
	"sqlID" INTEGER PRIMARY KEY,
	"ID" TEXT UNIQUE NOT NULL,
	"lastModificationDate" TEXT,
	"class" TEXT NOT NULL,
	"string" TEXT,
	"dateType" TEXT,
	"date" TEXT,
	"dateOperator" TEXT,
	"dateDuration" INTEGER, "dateDurationUnit" INTEGER,
	"number" TEXT,
	"color" TEXT,
	"constant" TEXT,
	"object" TEXT
);

-- Conditions

CREATE TABLE LACondition (
	"sqlID" INTEGER PRIMARY KEY,
	"ID" TEXT UNIQUE NOT NULL,
	"lastModificationDate" TEXT,
	"class" TEXT NOT NULL,
	"parent" TEXT,
	"index" INTEGER NOT NULL,
	"type" INTEGER,
	"keyPath" TEXT,
	"operator" TEXT,
	"parameter" TEXT
);

CREATE INDEX LAConditionParentIndex ON LACondition ("parent");

-- Filters

CREATE TABLE LASavedCondition (
	"sqlID" INTEGER PRIMARY KEY,
	"ID" TEXT UNIQUE NOT NULL,
	"lastModificationDate" TEXT,
	"filtersBarData" TEXT NOT NULL,
	"index" INTEGER NOT NULL,
	"name" TEXT NOT NULL,
	"condition" TEXT NOT NULL
);

CREATE TABLE LAFiltersBarData (
	"sqlID" INTEGER PRIMARY KEY,
	"ID" TEXT UNIQUE NOT NULL,
	"lastModificationDate" TEXT,
	"name" TEXT NOT NULL,
	"values" TEXT,
	"condition" TEXT
);

-- Rules

CREATE TABLE LARule (
	"sqlID" INTEGER PRIMARY KEY,
	"ID" TEXT UNIQUE NOT NULL,
	"lastModificationDate" TEXT,
	"class" TEXT NOT NULL,
	"parent" TEXT NOT NULL,
	"index" INTEGER NOT NULL,
	"name" TEXT NOT NULL,
	"active" INTEGER NOT NULL,
	"condition" TEXT
);

CREATE TABLE LAAction (
	"sqlID" INTEGER PRIMARY KEY,
	"ID" TEXT UNIQUE NOT NULL,
	"lastModificationDate" TEXT,
	"rule" TEXT NOT NULL,
	"index" INTEGER NOT NULL,
	"name" TEXT NOT NULL,
	"parameter1" TEXT,
	"parameter2" TEXT,
	"parameter3" TEXT,
	"parameter4" TEXT,
	"parameter5" TEXT
);

CREATE INDEX LAActionRuleIndex ON LAAction ("rule");
