var visibleDiv = null;
var activeLink = null;

$(document).ready(function() {
	if (location.hash != "#print") {
		if (location.hash) {
			visibleDiv = $(location.hash);
		}
		if (!visibleDiv || !visibleDiv.is("div")) {
			visibleDiv = $("#documents");
		}
		if (!visibleDiv || !visibleDiv.is("div")) {
			visibleDiv = $(".help:first");
		}
	}
	var menu = $("#help_menu");
	$(".help").each(function(index, div) {
		var link = $("<a href='#" + $(div).attr("id") + "'>" + $(div).find("h1").text() + "</a>");
		menu.append($("<li>").append(link));
		if (visibleDiv) {
			if ($(div).is(visibleDiv)) {
				activeLink = link;
				activeLink.addClass("active");
			} else {
				$(div).hide();
			}
		}
	});
	if (location.hash == "#print") {
		window.print();
	} else {
		var sections = $('.help')
		sections.each(function(index, div) {
			if (index > 0) {
				var previousSection = $(sections[index - 1]);
				$(div).append("<a class='left' href='#" + previousSection.attr("id") + "'>&lt; " + previousSection.find("h1").text() + "</a>");
			}
			if (index < sections.length - 1) {
				var nextSection = $(sections[index + 1]);
				$(div).append("<a class='right' href='#" + nextSection.attr("id") + "'>" + nextSection.find("h1").text() + " &gt;</a>");
			}
			$(div).append("<div class='clear'></div>");
		});
	}
});

if (location.hash != "#print") {
	$(window).bind('hashchange', function() {
		activeLink.removeClass("active");
		visibleDiv.fadeToggle(function() {
			$("html, body").animate({scrollTop: 0}, "slow");
			if (location.hash) {
				visibleDiv = $(location.hash);
			} else {
				visibleDiv = null;
			}
			if (!visibleDiv || !visibleDiv.is("div")) {
				visibleDiv = $("#documents");
			}
			visibleDiv.fadeToggle();
			activeLink = $("#help_menu li a[href='" + location.hash + "']");
			activeLink.addClass("active");
		});
	});
}
