var width = 0;

$(document).ready(function() {
	$("#nav li a").each(function() {
		if ($(this).next().length > 0) {
			$(this).addClass("parent");
		};
	})
	$("#menu").click(function(event) {
		event.preventDefault();
		$(this).toggleClass("active");
		$("#nav").toggle();
	});
	width = document.body.clientWidth;
	updateMenu();
	updateBody();
})

$(window).bind("resize orientationchange", function() {
	width = document.body.clientWidth;
	updateMenu();
	updateBody();
});

function updateMenu() {
	if (width < 768) {
		$("#menu").css("display", "inline-block");
		if (!$("#menu").hasClass("active")) {
			$("#nav").hide();
		} else {
			$("#nav").show();
		}
		$("#nav li").unbind("mouseenter mouseleave");
		$("#nav li a.parent").unbind("click").bind("click", function(event) {
			// Must be attached to anchor element to prevent bubbling
			event.preventDefault();
			$(this).parent("li").toggleClass("hover");
		});
	} else if (width >= 768) {
		$("#menu").css("display", "none");
		$("#nav").show();
		$("#nav li").removeClass("hover");
		$("#nav li a").unbind("click");
		$("#nav li").unbind("mouseenter mouseleave").bind("mouseenter mouseleave", function() {
		 	// Must be attached to li so that mouseleave is not triggered when hover over submenu
		 	$(this).toggleClass("hover");
		});
	}
}

function updateBody() {
	$("#body").css("min-height", ($(window).height() - $("header").height() - $("footer").height()) + "px");
}

$(window).load(function() {
	$(".flexslider").flexslider({
		animation: "fade",
		useCSS: false,
		smoothHeight: true,
		controlNav: false,
		prevText: "&lsaquo;",
		nextText: "&rsaquo;",
	});
	$(".fancybox").fancybox({
    	padding : 4,
    	openEffect	: 'elastic',
    	closeEffect	: 'elastic',
    });
});
